﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Universidade {
    class Cadastro {
        List<Universitario> l = new List<Universitario>();

        public void leitura(StreamReader leitor) {
            string tipo;
            while(!leitor.EndOfStream) {
                tipo = leitor.ReadLine();
                if (tipo.Equals("p")) {
                    Professor p = new Professor();
                    p.leitura(leitor);
                    l.Add(p);
                }else if(tipo.Equals("a")) {
                    Aluno a = new Aluno();
                    a.leitura(leitor);
                    l.Add(a);
                }
            }
        }

        public void criaListaAluno(StreamWriter saida) {
            List<Aluno> la = new List<Aluno>();
            foreach(Universitario u in l) {
                if(u is Aluno){
                    la.Add((Aluno)u);
                }
            }
            la.Sort();
            foreach(Aluno a in la) {
                a.imprime(saida);
            }
        }

        public void criaListaProfessor(StreamWriter saida) {
            List<Professor> lp = new List<Professor>();
            foreach (Universitario u in l)
            {
                if (u is Professor)
                {
                    lp.Add((Professor)u);
                }
            }
            lp.Sort();
            foreach (Professor p in lp)
            {
                p.imprime(saida);
            }
        }

        public void imprime(StreamWriter saida) {
            foreach(Universitario u in l) {
                u.imprime(saida);
                saida.WriteLine();
            }
            
        }

        static void Main() {
              Stream entrada = File.Open(@Directory.GetCurrentDirectory()+"/entrada.txt", FileMode.Open);
              StreamReader leitor = new StreamReader(entrada);
              StreamWriter saidaAluno = new StreamWriter(@Directory.GetCurrentDirectory()+"/saidaAluno.txt");
              StreamWriter saidaProfessor = new StreamWriter(@Directory.GetCurrentDirectory()+"/saidaProfessor.txt");

              Cadastro c = new Cadastro();

              c.leitura(leitor);
              c.criaListaAluno(saidaAluno);
              c.criaListaProfessor(saidaProfessor);

              leitor.Close();
              entrada.Close();
              saidaAluno.Close();
              saidaProfessor.Close();
          
        }
    }
}
